Index: Singular/LIB/ainvar.lib
===================================================================
--- Singular/LIB/ainvar.lib	(revision 73d7b5cf051d2bb349542039ed3ac2b513f7c109)
+++ Singular/LIB/ainvar.lib	(revision 034ce12c4d5c236b70e0d93d3dd39cefcbe60268)
@@ -1,6 +1,6 @@
-// $Id: ainvar.lib,v 1.1 1999-12-13 15:53:37 obachman Exp $
+// $Id: ainvar.lib,v 1.2 2000-05-12 12:25:40 Singular Exp $
 /////////////////////////////////////////////////////////////////////////////
 
-version="$Id: ainvar.lib,v 1.1 1999-12-13 15:53:37 obachman Exp $";
+version="$Id: ainvar.lib,v 1.2 2000-05-12 12:25:40 Singular Exp $";
 info="
 LIBRARY: ainvar.lib   PROCEDURES FOR COMPUTING INVARIANTS RINGS OF THE ADDITIVE GROUP
@@ -107,5 +107,5 @@
 
   //changes the basering bsr to bsr[@t]
-  execute "ring s="+charstr(basering)+",("+varstr(basering)+",@t),dp;";
+  execute("ring s="+charstr(basering)+",("+varstr(basering)+",@t),dp;");
   poly inv,delta,tee,j;
   ideal id=imap(bsr,id);
@@ -216,8 +216,8 @@
 
   //------------- changes the basering bsr to bsr[@(0),...,@(z)] ----------
-  execute "ring s="+charstr(basering)+",("+varstr(basering)+",@(0..z)),dp;";
+  execute("ring s="+charstr(basering)+",("+varstr(basering)+",@(0..z)),dp;");
 // Ev hier die Reihenfolge der Vars aendern. Dazu muss unten aber entsprechend
 // geaendert werden:
-//  execute "ring s="+charstr(basering)+",(@(0..z),"+varstr(basering)+"),dp;";
+//  execute("ring s="+charstr(basering)+",(@(0..z),"+varstr(basering)+"),dp;");
 
   //constructs the leading ideal of dom=(p-@(0),dom[1]-@(1),...,dom[z]-@(z))
Index: Singular/LIB/algebra.lib
===================================================================
--- Singular/LIB/algebra.lib	(revision 73d7b5cf051d2bb349542039ed3ac2b513f7c109)
+++ Singular/LIB/algebra.lib	(revision 034ce12c4d5c236b70e0d93d3dd39cefcbe60268)
@@ -1,4 +1,4 @@
 ///////////////////////////////////////////////////////////////////////////////
-version="$Id: algebra.lib,v 1.4 1999-08-05 10:53:29 obachman Exp $";
+version="$Id: algebra.lib,v 1.5 2000-05-12 12:25:41 Singular Exp $";
 info="
 LIBRARY:  algebra.lib   PROCEDURES FOR COMPUTING WITH ALGBRAS AND MAPS
@@ -584,5 +584,5 @@
     string mp=string(minpoly);
   // ------------ create new ring with extra variables ---------------------
-  execute ("ring R=("+charstr(br)+"),(x(1..n),y(1..m)),(dp(n),dp(m));");
+    execute ("ring R=("+charstr(br)+"),(x(1..n),y(1..m)),(dp(n),dp(m));");
     execute ("minpoly=number("+mp+");");
     ideal vars = x(1..n);
@@ -655,5 +655,5 @@
     string mp=string(minpoly);
   // ------------ create new ring with extra variables ---------------------
-  execute ("ring R=("+charstr(br)+"),(x(1..n),y(1..m)),(dp(n),dp(m));");
+    execute ("ring R=("+charstr(br)+"),(x(1..n),y(1..m)),(dp(n),dp(m));");
     execute ("minpoly=number("+mp+");");
     ideal vars = x(1..n);
Index: Singular/LIB/classify.lib
===================================================================
--- Singular/LIB/classify.lib	(revision 73d7b5cf051d2bb349542039ed3ac2b513f7c109)
+++ Singular/LIB/classify.lib	(revision 034ce12c4d5c236b70e0d93d3dd39cefcbe60268)
@@ -1,7 +1,7 @@
-e// $Id: classify.lib,v 1.41 2000-05-05 18:40:29 obachman Exp $
+e// $Id: classify.lib,v 1.42 2000-05-12 12:25:41 Singular Exp $
 // KK, last modified: 04.04.1998
 ///////////////////////////////////////////////////////////////////////////////
 
-version  = "$Id: classify.lib,v 1.41 2000-05-05 18:40:29 obachman Exp $";
+version  = "$Id: classify.lib,v 1.42 2000-05-12 12:25:41 Singular Exp $";
 info="
 LIBRARY:  classify.lib  Procedures for the Arnold-Classifier of Singularities
@@ -2368,6 +2368,6 @@
     S = "f = ", Tp, ";";
     debug_log(2,"S=", S, " Tp=", Tp, "Key=", Key);
-    execute S;
-    execute read(dbmLink, Key)+";";
+    execute(S);
+    execute(read(dbmLink, Key)+";");
     debug_log(1, "Polynom f=", f,  "  crk=", crk, "  Mu=", Mu,
                 " MlnCd=", MlnCd);
@@ -2486,5 +2486,5 @@
     if( s != "" && defined(@DeBug)==0) {
       s="newDebug="+s;
-      execute s;
+      execute(s);
     }
   }
@@ -2658,5 +2658,5 @@
   def ring_save=basering;
 
-  execute @ringdisplay;
+  execute(@ringdisplay);
   map showpoly=ring_save,maxideal(1);
   s = string(showpoly(g));
@@ -2708,5 +2708,5 @@
     debug_log(8, "  Number of columns: 0");
     s2 = "k = "+s1+";";
-    execute s2;
+    execute(s2);
     if( (Typ=="A[") || (Typ=="D[") ) { s3 = "k"; }
     if( Typ == "E[") { t = 6; }
@@ -2743,10 +2743,10 @@
     b  = find(s1, ",");
     s2 = "k = ",s1[1..b-1],";";
-    execute s2;
+    execute(s2);
     s1 = s1[b+1..size(s1)];
     if(find(s1, ",") == 0) {
       debug_log(8, "  Number of columns 1");
       s2 = "r = "+s1+";";
-      execute s2;
+      execute(s2);
       s4 = "r";
       s3 = "k";
@@ -2768,7 +2768,7 @@
       b  = find(s1, ",");
       s2 = "r = ",s1[1..b-1],";";
-      execute s2;
+      execute(s2);
       s2 = "s = ",s1[b+1..size(s1)],";";
-      execute s2;
+      execute(s2);
       if(Typ=="Y[") { s2 = "Y[k,r,s]"; }
       if(Typ=="Z[") { s2 = "Z[k,r,s]"; }
Index: Singular/LIB/deform.lib
===================================================================
--- Singular/LIB/deform.lib	(revision 73d7b5cf051d2bb349542039ed3ac2b513f7c109)
+++ Singular/LIB/deform.lib	(revision 034ce12c4d5c236b70e0d93d3dd39cefcbe60268)
@@ -1,7 +1,7 @@
-// $Id: deform.lib,v 1.20 2000-05-12 12:20:25 krueger Exp $
+// $Id: deform.lib,v 1.21 2000-05-12 12:25:42 Singular Exp $
 // author: Bernd Martin email: martin@math.tu-cottbus.de
 //(bm, last modified 4/98)
 ///////////////////////////////////////////////////////////////////////////////
-version="$Id: deform.lib,v 1.20 2000-05-12 12:20:25 krueger Exp $";
+version="$Id: deform.lib,v 1.21 2000-05-12 12:25:42 Singular Exp $";
 info="
 LIBRARY:  deform.lib       PROCEDURES FOR COMPUTING MINIVERSAL DEFORMATION
@@ -660,8 +660,8 @@
    string my_Ox = my+"Ox";
    string my_So = my+"So";
-  extendring(my_Px,e1,my_var,my_ord);
+   extendring(my_Px,e1,my_var,my_ord);
    ideal Io  = imap(Po,Io);         attrib(Io,"isSB",1);
    my ="qring "+my_Qx+" = Io;       export("+my_Qx+");";
-  execute(my);
+   execute(my);
    if (switch)
    {
Index: Singular/LIB/factor.lib
===================================================================
--- Singular/LIB/factor.lib	(revision 73d7b5cf051d2bb349542039ed3ac2b513f7c109)
+++ Singular/LIB/factor.lib	(revision 034ce12c4d5c236b70e0d93d3dd39cefcbe60268)
@@ -1,7 +1,7 @@
-// $Id: factor.lib,v 1.6 1998-05-14 18:44:59 Singular Exp $
+// $Id: factor.lib,v 1.7 2000-05-12 12:25:43 Singular Exp $
 //(RS)
 ///////////////////////////////////////////////////////////////////////////////
 
-version="$Id: factor.lib,v 1.6 1998-05-14 18:44:59 Singular Exp $";
+version="$Id: factor.lib,v 1.7 2000-05-12 12:25:43 Singular Exp $";
 info="
 LIBRARY:  factor.lib    PROCEDURES FOR CALLING THE REDUCE FACTORIZER
@@ -73,5 +73,5 @@
   {
     resultstring = delete_dollar( resultstring );
-    execute resultstring;
+    execute(resultstring);
   }
   // remove tmp-files after usage */
Index: Singular/LIB/finvar.lib
===================================================================
--- Singular/LIB/finvar.lib	(revision 73d7b5cf051d2bb349542039ed3ac2b513f7c109)
+++ Singular/LIB/finvar.lib	(revision 034ce12c4d5c236b70e0d93d3dd39cefcbe60268)
@@ -1,7 +1,7 @@
-// $Id: finvar.lib,v 1.26 2000-05-02 14:52:48 Singular Exp $
+// $Id: finvar.lib,v 1.27 2000-05-12 12:25:43 Singular Exp $
 // author: Agnes Eileen Heydtmann, email:agnes@math.uni-sb.de
 // last change: 98/11/05
 ///////////////////////////////////////////////////////////////////////////////
-version="$Id: finvar.lib,v 1.26 2000-05-02 14:52:48 Singular Exp $"
+version="$Id: finvar.lib,v 1.27 2000-05-12 12:25:43 Singular Exp $"
 info="
 LIBRARY:  finvar.lib       LIBRARY TO CALCULATE INVARIANT RINGS OF FINITE GROUPS
@@ -765,9 +765,10 @@
     if (minpoly==0)
     { if (i>size(chst))
-      { execute "ring "+newring+"=0,("+varstr(br)+"),("+ordstr(br)+")";
+      { execute("ring "+newring+"=0,("+varstr(br)+"),("+ordstr(br)+")");
       }
       else
       { chst=chst[i..size(chst)];
-        execute "ring "+newring+"=(0"+chst+"),("+varstr(br)+"),("+ordstr(br)+")";
+        execute
+        ("ring "+newring+"=(0"+chst+"),("+varstr(br)+"),("+ordstr(br)+")");
       }
     }
@@ -776,6 +777,6 @@
       minp=minp[2..size(minp)-1];
       chst=chst[i..size(chst)];
-      execute "ring "+newring+"=(0"+chst+"),("+varstr(br)+"),("+ordstr(br)+")";
-      execute "minpoly="+minp;
+      execute("ring "+newring+"=(0"+chst+"),("+varstr(br)+"),("+ordstr(br)+")");
+      execute("minpoly="+minp);
     }
     matrix I=diag(1,n);
@@ -813,5 +814,5 @@
       }
       setring `newring`;
-      execute "matrix G(i)["+string(n)+"]["+string(n)+"]="+stM(i);
+      execute("matrix G(i)["+string(n)+"]["+string(n)+"]="+stM(i));
       p=det(I-v1*G(i));                // denominator of new term -
       M[1,1]=M[1,1]*p+M[1,2];          // expanding M[1,1]/M[1,2] + 1/p
@@ -1202,9 +1203,10 @@
     if (minpoly==0)
     { if (i>size(chst))
-      { execute "ring "+newring+"=0,("+varstr(br)+"),("+ordstr(br)+")";
+      { execute("ring "+newring+"=0,("+varstr(br)+"),("+ordstr(br)+")");
       }
       else
       { chst=chst[i..size(chst)];
-        execute "ring "+newring+"=(0"+chst+"),("+varstr(br)+"),("+ordstr(br)+")";
+        execute
+	("ring "+newring+"=(0"+chst+"),("+varstr(br)+"),("+ordstr(br)+")");
       }
     }
@@ -1213,6 +1215,6 @@
       minp=minp[2..size(minp)-1];
       chst=chst[i..size(chst)];
-      execute "ring "+newring+"=(0"+chst+"),("+varstr(br)+"),("+ordstr(br)+")";
-      execute "minpoly="+minp;
+      execute("ring "+newring+"=(0"+chst+"),("+varstr(br)+"),("+ordstr(br)+")");
+      execute("minpoly="+minp);
     }
     poly v1=var(1);                    // the Molien series will be in terms of
@@ -1234,5 +1236,5 @@
     }
     setring `newring`;
-    execute "matrix G(1)["+string(n)+"]["+string(n)+"]="+stM(1);
+    execute("matrix G(1)["+string(n)+"]["+string(n)+"]="+stM(1));
     matrix A(2)[1][2];                 // A(2) will contain the Molien series -
     A(2)[1,1]=1;                       // A(2)[1,1] will be the numerator
@@ -1271,5 +1273,5 @@
         }
         setring `newring`;
-        execute "matrix G(i)["+string(n)+"]["+string(n)+"]="+stM(i);
+        execute("matrix G(i)["+string(n)+"]["+string(n)+"]="+stM(i));
         p=det(I-v1*G(i));              // denominator of new term -
         A(2)[1,1]=A(2)[1,1]*p+A(2)[1,2]; // expanding A(2)[1,1]/A(2)[1,2] +1/p
@@ -1330,5 +1332,5 @@
           }
           setring `newring`;
-          execute "matrix G(g)["+string(n)+"]["+string(n)+"]="+stM(g);
+          execute("matrix G(g)["+string(n)+"]["+string(n)+"]="+stM(g));
           p=det(I-v1*G(g));            // denominator of new term
           A(2)[1,1]=A(2)[1,1]*p+A(2)[1,2];
@@ -1473,6 +1475,6 @@
     poly A(1)=M[1,2];                  // denominator of Molien series (for now)
     string mp=string(minpoly);
-    execute "ring R=("+charstr(br)+"),("+varstr(br)+"),ds;";
-    execute "minpoly=number("+mp+");";
+    execute("ring R=("+charstr(br)+"),("+varstr(br)+"),ds;");
+    execute("minpoly=number("+mp+");");
     poly A(1)=0;                       // A(1) will contain the sum of n terms -
     poly min;                          // min will be our smallest term -
@@ -1596,7 +1598,7 @@
   }
  //----------------------------------------------------------------------------
-  execute "ring T=("+charstr(br)+"),("+varstr(br)+",p(1..m)),lp;";
+  execute("ring T=("+charstr(br)+"),("+varstr(br)+",p(1..m)),lp;");
   // p(1..m) are the general coefficients of the general polynomial of degree g
-  execute "ideal vars="+varstr(br)+";";
+  execute("ideal vars="+varstr(br)+";");
   map f;
   ideal mon=imap(br,mon);
@@ -3045,5 +3047,5 @@
           }
           if (not(flag))
-          { execute "test_dim="+string(answer[1..size(answer)]);
+          { execute("test_dim="+string(answer[1..size(answer)]));
             if (test_dim<=max)
             { flag=1;
@@ -3154,5 +3156,5 @@
             }
             if (not(flag))
-            { execute "test_dim="+string(answer[1..size(answer)]);
+            { execute("test_dim="+string(answer[1..size(answer)]));
               if (test_dim<=max)
               { flag=1;
@@ -5116,6 +5118,6 @@
   string mp=string(minpoly);           // generating a ring where we can do
                                        // elimination
-  execute "ring R=("+charstr(br)+"),(x(1..n),y(1..n),h),dp;";
-  execute "minpoly=number("+mp+");";
+  execute("ring R=("+charstr(br)+"),(x(1..n),y(1..n),h),dp;");
+  execute("minpoly=number("+mp+");");
   map f=br,maxideal(1);                // canonical mapping
   matrix M[k][m+k*n];
@@ -5640,6 +5642,6 @@
     int m=ncols(F);
     string mp=string(minpoly);
-    execute "ring R=("+charstr(br)+"),("+varstr(br)+",y(1..m)),dp;";
-    execute "minpoly=number("+mp+");";
+    execute("ring R=("+charstr(br)+"),("+varstr(br)+",y(1..m)),dp;");
+    execute("minpoly=number("+mp+");");
     ideal I=ideal(imap(br,F));
     for (int i=1;i<=m;i++)
@@ -5647,6 +5649,6 @@
     }
     I=elim(I,1,n);
-    execute "ring "+newring+"=("+charstr(br)+"),(y(1..m)),dp(m);";
-    execute "minpoly=number("+mp+");";
+    execute("ring "+newring+"=("+charstr(br)+"),(y(1..m)),dp(m);");
+    execute("minpoly=number("+mp+");");
     ideal vars;
     for (i=2;i<=n;i++)
@@ -5658,5 +5660,4 @@
     kill emb, vars, R;
     keepring `newring`;
-    // execute "keepring "+newring+";";
     return();
   }
@@ -5701,6 +5702,6 @@
     int m=ncols(F);
     string mp=string(minpoly);
-    execute "ring R=("+charstr(br)+"),("+varstr(br)+",y(1..m)),lp;";
-    execute "minpoly=number("+mp+");";
+    execute("ring R=("+charstr(br)+"),("+varstr(br)+",y(1..m)),lp;");
+    execute("minpoly=number("+mp+");");
     ideal J=ideal(imap(br,F));
     ideal I=imap(br,I);
@@ -5727,6 +5728,6 @@
     }
     G=compress(G);
-    execute "ring "+newring+"=("+charstr(br)+"),(y(1..m)),lp;";
-    execute "minpoly=number("+mp+");";
+    execute("ring "+newring+"=("+charstr(br)+"),(y(1..m)),lp;");
+    execute("minpoly=number("+mp+");");
     ideal vars;
     for (i=2;i<=n;i++)
@@ -5738,5 +5739,4 @@
     kill vars, emb;
     keepring `newring`;
-    // execute "keepring "+newring+";";
     return();
   }
@@ -5775,5 +5775,5 @@
     string newring="E";
     relative_orbit_variety(I,F,newring);
-    execute "ring R=("+charstr(br)+"),("+varstr(br)+","+varstr(E)+"),lp;";
+    execute("ring R=("+charstr(br)+"),("+varstr(br)+","+varstr(E)+"),lp;");
     ideal F=imap(br,F);
     for (int i=1;i<=n;i++)
Index: Singular/LIB/general.lib
===================================================================
--- Singular/LIB/general.lib	(revision 73d7b5cf051d2bb349542039ed3ac2b513f7c109)
+++ Singular/LIB/general.lib	(revision 034ce12c4d5c236b70e0d93d3dd39cefcbe60268)
@@ -1,7 +1,7 @@
-// $Id: general.lib,v 1.26 2000-04-27 10:07:13 obachman Exp $
+// $Id: general.lib,v 1.27 2000-05-12 12:25:47 Singular Exp $
 //GMG, last modified 18.6.99
 ///////////////////////////////////////////////////////////////////////////////
 
-version="$Id: general.lib,v 1.26 2000-04-27 10:07:13 obachman Exp $";
+version="$Id: general.lib,v 1.27 2000-05-12 12:25:47 Singular Exp $";
 info="
 LIBRARY:  general.lib   PROCEDURES OF GENERAL TYPE
@@ -80,5 +80,5 @@
    string sR = "ring R = (0,"+A_Z("A",6)+"),("+A_Z("a",10)+"),dp;";
    sR;
-   execute sR;
+   execute(sR);
    R;
 }
@@ -740,5 +740,5 @@
       if( find(os,",") )
       {
-         execute "nw = "+os+";";
+         execute("nw = "+os+";");
          if( size(nw) > ii )
          {
@@ -751,5 +751,5 @@
       else
       {
-         execute "q = "+os+";";
+         execute("q = "+os+";");
          if( q > ii )
          {
@@ -853,5 +853,5 @@
       if ( typeof(#[1])=="string" )
       {
-         execute "ring r1 =("+charstr(P)+"),("+varstr(P)+"),("+#[1]+");";
+         execute("ring r1 =("+charstr(P)+"),("+varstr(P)+"),("+#[1]+");");
          def i = imap(P,id);
          v = sortvec(i);
@@ -881,5 +881,5 @@
          }
       }
-      execute "ring r=0,x(1..s),("+o+");";
+      execute("ring r=0,x(1..s),("+o+");");
       ideal i;
       poly f;
Index: Singular/LIB/hnoether.lib
===================================================================
--- Singular/LIB/hnoether.lib	(revision 73d7b5cf051d2bb349542039ed3ac2b513f7c109)
+++ Singular/LIB/hnoether.lib	(revision 034ce12c4d5c236b70e0d93d3dd39cefcbe60268)
@@ -1,8 +1,8 @@
-// $Id: hnoether.lib,v 1.19 2000-04-27 21:06:09 lamm Exp $
+// $Id: hnoether.lib,v 1.20 2000-05-12 12:25:47 Singular Exp $
 // last change:           27.04.00
 ///////////////////////////////////////////////////////////////////////////////
 // This library is for Singular 1-3-7 or newer
 
-version="$Id: hnoether.lib,v 1.19 2000-04-27 21:06:09 lamm Exp $";
+version="$Id: hnoether.lib,v 1.20 2000-05-12 12:25:47 Singular Exp $";
 info="
 LIBRARY:  hnoether.lib   Procedures for the Hamburger-Noether (Puiseux) development
@@ -281,5 +281,5 @@
   }
   execute("ring rsqrf = ("+charstr(altring)+"),(x,y),dp;");
-  if ((gcd_ok!=0) && (mipl!="0")) { execute "minpoly="+mipl+";"; }
+  if ((gcd_ok!=0) && (mipl!="0")) { execute("minpoly="+mipl+";"); }
   poly f=fetch(altring,f);
   poly dif,g,l;
@@ -376,5 +376,5 @@
  }
  execute("ring rsqrf = ("+charstr(altring)+"),(x,y),dp;");
- if (mipl!="0") { execute "minpoly="+mipl+";"; }
+ if (mipl!="0") { execute("minpoly="+mipl+";"); }
  poly f=fetch(altring,f);
  poly l=fetch(altring,l);
@@ -558,5 +558,5 @@
    execute("ring guenstig = ("+charstr(altring)+"),(x,y),ls;");
    if ((char(basering)==0) && (mipl!="0")) {
-     execute "minpoly="+mipl+";";
+     execute("minpoly="+mipl+";");
    }}
  else { def guenstig=basering; }
@@ -591,5 +591,5 @@
  if ((p!=0) and (ringchar != string(p))) {
                             // coefficient field is extension of Z/pZ
-   execute "int n_elements="+ringchar[1,size(ringchar)-2]+";";
+   execute("int n_elements="+ringchar[1,size(ringchar)-2]+";");
                             // number of elements of actual ring
    number generat=par(1);   // generator of the coefficient field of the ring
@@ -1789,5 +1789,5 @@
    if (charstr(basering)!=string(char(basering))+","+parstr(basering)) {
      execute
-       "ring dazu=("+charstr(basering)+"),z(0.."+string(size(v)-1)+"),ls;";
+      ("ring dazu=("+charstr(basering)+"),z(0.."+string(size(v)-1)+"),ls;");
    }
    else { ring dazu=char(altring),z(0..size(v)-1),ls; }
@@ -2059,14 +2059,14 @@
      if (tststr==string(p)) {
        if (size(parstr(basering))>1) {         // ring (p,a,..),...
-        execute "ring extdguenstig=("+charstr(basering)+"),(x,y),ls;";
+        execute("ring extdguenstig=("+charstr(basering)+"),(x,y),ls;");
        }
        else {                                  // ring (p,a),...
         string mipl=string(minpoly);
         ring extdguenstig=(p,`parstr(basering)`),(x,y),ls;
-        if (mipl!="0") { execute "minpoly="+mipl+";"; }
+        if (mipl!="0") { execute("minpoly="+mipl+";"); }
        }
      }
      else {
-       execute "ring extdguenstig=("+charstr(basering)+"),(x,y),ls;";
+       execute("ring extdguenstig=("+charstr(basering)+"),(x,y),ls;");
      }
   }
@@ -2314,8 +2314,8 @@
    string strmip=string(minpoly);
    string strf=string(f);
-   execute "ring tempr=("+string(char(basering))+","+parstr(basering)+"),("
-           +varstr(basering)+"),dp;";
-   execute "minpoly="+strmip+";";
-   execute "poly f="+strf+";";
+   execute("ring tempr=("+string(char(basering))+","+parstr(basering)+"),("
+           +varstr(basering)+"),dp;");
+   execute("minpoly="+strmip+";");
+   execute("poly f="+strf+";");
    list hne=reddevelop(f);
    if ((voice==2) && (printlevel > -1)) {
@@ -2341,5 +2341,5 @@
      string strmip=string(minpoly);
      ring HNEring=(char(altring),`parstr(altring)`),(x,y),ls;
-     execute "minpoly="+strmip+";";
+     execute("minpoly="+strmip+";");
      export HNEring;
      poly f=fetch(altring,f);
@@ -2495,5 +2495,5 @@
      " ** occurs during the calculation, we cannot proceed with the";
      " ** corresponding branches ...";
-     execute "ring HNEring=("+charstr(basering)+"),(x,y),ls;";
+     execute("ring HNEring=("+charstr(basering)+"),(x,y),ls;");
  //--- ring ...=(char(.),`parstr()`),... geht nicht, wenn mehr als 1 Param. ---
    }
@@ -2501,9 +2501,9 @@
     string pa=parstr(altring);
     ring HNhelpring=p,`pa`,dp;
-    execute "poly mipo="+mipl+";";   // Minimalpolynom in Polynom umgewandelt
+    execute("poly mipo="+mipl+";");  // Minimalpolynom in Polynom umgewandelt
     ring HNEring=(p,a),(x,y),ls;
     map getminpol=HNhelpring,a;
     mipl=string(getminpol(mipo));    // String umgewandelt mit 'a' als Param.
-    execute "minpoly="+mipl+";";     // "minpoly=poly is not supported"
+    execute("minpoly="+mipl+";");     // "minpoly=poly is not supported"
     kill HNhelpring, getminpol;
    }