Index: Tst/Manual/all_lib.res.gz.uu
===================================================================
--- Tst/Manual/all_lib.res.gz.uu	(revision 228e0b9cc53f11a9505d906eff83075191259c23)
+++ Tst/Manual/all_lib.res.gz.uu	(revision 36bbdc3dfa334fe6124fb5d32f3208f3ed729161)
@@ -1,22 +1,23 @@
-begin 640 all_lib.res.gz
-M'XL("&`H<DX``V%L;%]L:6(N<F5S`+V:P4[D,`R&[SQ%M>(`'*:"Y88TTJ*]
-M(,%>V#WL";FIVX9)X^"D`\/3KSN`]@G^'$;3JDT^I4[\VW$>?_^\^]4TS>6V
-MN;^[;;Z57#;!=]]N&KMZ\M&7L_.;D_6_V6X;"N')GFXBOVYRH7+R^-G\:MM(
-M*E[B61#J[WUGC;Z>??_LVAI_='W2MLW%1;.^R7W3[DE;6HH,N8WVRVX*2TKM
-MN'`N[2PETZY]^+MYH#*UMS]N_[39QW$)UNKQZ\+Z;S^[;T[O^E,,X66FHOX-
-M3$FL*A$,B:Z(A`RG#&0@A6-Z=C(G.(;""&;XN)>P%#!EW/5^!C,&91X[-"01
-M?B3]++UU58%""3V'5PH8X3@6);0O[H8%[2/?624S>BV^LF?-!3V]BDKR#FX6
-MTT>*:"=IBN(=FL'DIES0BR4O.C`ZHE@AY#C[,5)9E"O@T`CS,,4/!S0FL2NZ
-MH`4F)[?H'FX6"7B&33$G$;YJ[.:Z^*L*&#1B8AJ<3&@,C9T',U3LU06M8T?*
-M#*=8'`Z/^!0_O93S.Q?"4RKX%J,\+S6^V*B4T`O2,)V/,GMX1&9I6'9!T*F^
-M,@4EM.-7BKV@Y?AELB1I"6A_F=3/OOA]!4S/SD=T(O,)@E.J.)LDX3#3K@8&
-MCC#3>_3"3).//3R1262N.5#D8[P,W[TL-69:%)TI^/<J&#B$R\3HN&E6/MZ@
-M,74<VBP?88#O&6X?8_4J,]KEF'SB=TZJU&)6">@[=,`1X)6KX".^=A&HP!5@
-MEW>LD='?ZYF<=!E>A3-E3BKXFI+`*THV$K:\*724/5J7IT-BA4^!268)<-M,
-M=21SU%<*.SA$EH0VOD$Z)^BDZ;@%X!U\,'.NL,=HE`IYQLB1\66_H<;&'+\L
-MOH)=..!+USQ8W`^'..GQM?YCSI?@QG=Z2$70$(E%!;U8UC,Q6L$P@<R-P8MQ
-MSM;DG()W^#W33H^R#*90V?F(EA@SS9K'KG4`%?Q9&5)WW'!"8\+(G:+K&A3X
-MK8)RTLY>A(^EAG!2E]<#?_\I7T=`K[?'XZ3KD=$EGUV>WYR>_`.OQC)+>2H`
-!````
+begin 644 all_lib.res.gz
+M'XL("(XW(5```V%L;%]L:6(N<F5S`+6:36_;.!"&[_D51)%#4K16G:1HL0&\
+M:%&@&Z#82[SHL1E18XDUQ6&&5-+DU^_(28ONGE^=;$'28WIF.%^<Z^VGJ[^=
+M<^N-^W+UT;VHI:YB:%]<.OOV+:103TXOC^9/M]DXBO&;W5TEOE^52O7H^OGU
+MLXV37(.DDRC4?0FMO?3SWODSVEY^0A\UC7OYTLU/<N>:,=7FTX?MA^;SU?:O
+M?SXV]\WUUV9;:K/]W+0A-:M54P92;DI(_11)&\,USS1W?-4=0X"W(U4-/[#0
+MS*J2L,SDJT@L:.B.C*MH:L=>QHRF4NRQR)#N)$X5"^WW71BQR)TR]RV8F0F^
+MSFZ4[H[`UC1#*8.-:89BB9Y350)[IW8W@=W((ZL4!IO\/0?64L&*KRHY^-]%
+M:F'E3^<I):D6>#BYFRSQ8:0]S\_<@'XU4`+[&?.PP8.13'XH%6S$9=(=@X/A
+MS"3/)?2)ZJ2,IX.)MHUKV#V`J9E]U0GL<$OVD]ZA12H1CC3E>TEH:[6+BQK.
+M\%0P<6#:>1G`5.K;@$6J2+4-M0!T1$,M=4,G&@I7O')YY$IP*'Z#&O3[M,#?
+M[Y4RV.Z-:C=E#.ADRY+LXJ.`2RQEBDI@SS=#?:12X'%**74"CE*W@V7;4P0[
+MJZQA##7<X:E6O88$3I&?N6CH$KY`8O=[6@U<KE'11%-4`&^N/(34H;/@3.8)
+M(R4^)&SH-DY=P`R2Z$@Q/"Y!13.Y#@S.!D;EPP68NH@?&.4I'H:.T;(U=*<R
+M@O>MQ8.?M>O)^N+\W=M79V_6Z]=OWK\^.S^%[;<8&2V-!9K%LY_M6G#(C>@^
+M>0P)WGZ-5-%N=E_VK`FM]N_DI2WHCKZ%KJP";VD+NJ%MZV3+XV-+)8`#U_"0
+M6=':&F24B);KL$B0Z?6>XA[-E"F#]63,U@LXU3[4AL&CESH6?`?'H/CDM>?$
+M\!.#W0*-$;Z=`EZF'.''3[RS[!+-]-+!#]\.14!&Z\GK0ZX"9DJJ*F`CG0^'
+M%2_411HBWDQ_S#%X>+^IU4-,P4*I[D,"NU03ZURVS,U,%?BA,:D_E/%@:NRY
+M57#KE2+_P,<!VA?:HU>Z0!B@MLS3(O\[CIU'7=2)-Y>FQ@[)V64[>V)V3[-`
+G5CJP.__#W?QW'NCFUZC0Q>8P=C2/%DWE9'UZ>7ST+Z"9D@"A)```
 `
 end
Index: Tst/Manual/all_lib.stat
===================================================================
--- Tst/Manual/all_lib.stat	(revision 228e0b9cc53f11a9505d906eff83075191259c23)
+++ Tst/Manual/all_lib.stat	(revision 36bbdc3dfa334fe6124fb5d32f3208f3ed729161)
@@ -1,4 +1,4 @@
-1 >> tst_memory_0 :: 1316104113:3132- exportiert :3-1-3:ix86-Linux:mamawutz:583804
-1 >> tst_memory_1 :: 1316104113:3132- exportiert :3-1-3:ix86-Linux:mamawutz:666332
-1 >> tst_memory_2 :: 1316104113:3132- exportiert :3-1-3:ix86-Linux:mamawutz:699116
-1 >> tst_timer_1 :: 1316104113:3132- exportiert :3-1-3:ix86-Linux:mamawutz:42
+1 >> tst_memory_0 :: 1344354190:3.1.3.sw $Id: 6c9b669 Tue Aug 7 16:53:01 2012 +0200$:spielwiese:version:dilbert:762264
+1 >> tst_memory_1 :: 1344354190:3.1.3.sw $Id: 6c9b669 Tue Aug 7 16:53:01 2012 +0200$:spielwiese:version:dilbert:1150752
+1 >> tst_memory_2 :: 1344354190:3.1.3.sw $Id: 6c9b669 Tue Aug 7 16:53:01 2012 +0200$:spielwiese:version:dilbert:1183552
+1 >> tst_timer_1 :: 1344354190:3.1.3.sw $Id: 6c9b669 Tue Aug 7 16:53:01 2012 +0200$:spielwiese:version:dilbert:20
Index: Tst/Manual/modStd.res.gz.uu
===================================================================
--- Tst/Manual/modStd.res.gz.uu	(revision 228e0b9cc53f11a9505d906eff83075191259c23)
+++ Tst/Manual/modStd.res.gz.uu	(revision 36bbdc3dfa334fe6124fb5d32f3208f3ed729161)
@@ -1,15 +1,13 @@
-begin 640 modStd.res.gz
-M'XL("#@J<DX``VUO9%-T9"YR97,`W51-CYLP$+WG5XQ6/8#L0L9@V&T$4JM*
-M%:A*I<U*>ZBBB@!-J!)8!4<%?GW'[/+15'MI;^5BQO/FO>&-S>;A8[0&``SA
-M<_0!;E2MK&.QNUD!O7TKRD(9YFJA5PA#.%791F56F?^T:I6HQ>:E6KQ44[ZF
-M?$\P)IT0SD6YAWN$`);<:'C+.ZY,GCU-(#>$(LN3(T0$<AJ'-8(A!\16LM9A
-M@H/L7-8)YDXU<JB)J>:Y-2,RI[P70KQ:Q%]Q&Q`AVH[FM!W:$=N`V-"6FM"6
-MM.-L`U)"FP1)C9:1Q0_[G@[5J=H;$?4]"=R&KTG?_2FM]**NU%6OK]RK#FA;
-M]Z#D0(C+P40Q,Y$LK$=-Q+F%/Y*TVAD-F>>QSF=-VTW=H1B-PUG['/F20,'?
-M/XO']_?K:/WI'7RYJ*>+@E.Q/R@H*P6['!*@,U-FR3F#75(7-53?01UR*$J"
-M6O^D.WP8';48R7?LC6^9WWDZ(,.;CGFMU('VN6.R<77@4D:^]6D4O@XEY3P*
-MO>?0HT'=CN3N,`*G'T%CH&6Y)C].IQCE?`1IFQZ+U'!GQGNO&#^#^"-$_%^S
-MH<M2%UUNG//LDN9&C#P6)GW3<D3<72$$C_$WA*!;H']+^M]SJ0VR[<WB%V]Y
-&7^#!!```
+begin 644 modStd.res.gz
+M'XL("(@W(5```VUO9%-T9"YR97,`=5--3X-`$+WW5TR,AR6[0F?9!9NF'(P7
+MB/%@O9G&5"`54ULC:X3]]<YB"UC3TW9VWKR/V;)\O$WO`0`3N$MOX,+4QM]6
+M+Q=SH%_/U:XRS)M/W`E)`N_[8FD*?U=^^[59F\GR,"T/T]2OJ=\1],TP@<]J
+MMX$'A`5,!6M$*ZPPGB@^!I!*H"K*]192`H5-R!O)40!BJWD;<BE`6\6MY&J8
+MT<>9C&9^K;'4&_I1`ME\DCWA:D&$&(2.,PCI1JX6Q(:!=H2!IIMPM2`E#$B0
+MU.CH6>*D\_2Z?]]O6$J^!X'KY)ST[+^T<8<Y43>=OE$G#NC:>3#Z2(C3XQ+E
+M:(FTPKK71!RO\&V=[U]80\N+N(UYT]K!'<I^<3BR+U!,1R!ZM@PI`W8A6A[;
+MR!5DOK$\:K4KG&?+=:-<H:BCKV**%;M24R^B,OHM(PI]W9.K8YRPB],P]'WE
+MB>WPCT`]CI.W^;;*F1KYB\Z$&$'B'B+/YZ1'K"M;LL^R^,I+EJ'(I$?]:8^8
+=G2"DR/`/0M+KN,_%?1-?-2,+EY,?)':#3%D#````
 `
 end
Index: Tst/Manual/modStd.stat
===================================================================
--- Tst/Manual/modStd.stat	(revision 228e0b9cc53f11a9505d906eff83075191259c23)
+++ Tst/Manual/modStd.stat	(revision 36bbdc3dfa334fe6124fb5d32f3208f3ed729161)
@@ -1,4 +1,4 @@
-1 >> tst_memory_0 :: 1316104113:3132- exportiert :3-1-3:ix86-Linux:mamawutz:336520
-1 >> tst_memory_1 :: 1316104113:3132- exportiert :3-1-3:ix86-Linux:mamawutz:741376
-1 >> tst_memory_2 :: 1316104113:3132- exportiert :3-1-3:ix86-Linux:mamawutz:780980
-1 >> tst_timer_1 :: 1316104113:3132- exportiert :3-1-3:ix86-Linux:mamawutz:41
+1 >> tst_memory_0 :: 1344354184:3.1.3.sw $Id: 6c9b669 Tue Aug 7 16:53:01 2012 +0200$:spielwiese:version:dilbert:269264
+1 >> tst_memory_1 :: 1344354184:3.1.3.sw $Id: 6c9b669 Tue Aug 7 16:53:01 2012 +0200$:spielwiese:version:dilbert:669168
+1 >> tst_memory_2 :: 1344354184:3.1.3.sw $Id: 6c9b669 Tue Aug 7 16:53:01 2012 +0200$:spielwiese:version:dilbert:747000
+1 >> tst_timer_1 :: 1344354184:3.1.3.sw $Id: 6c9b669 Tue Aug 7 16:53:01 2012 +0200$:spielwiese:version:dilbert:14