Index: Singular/LIB/poly.lib
===================================================================
--- Singular/LIB/poly.lib	(revision fa1af627353fd9365bd5fdad189f015e30251a16)
+++ Singular/LIB/poly.lib	(revision 38c1655b00c7eaba87af5a330f66679d70e33495)
@@ -1,8 +1,8 @@
-// $Id: poly.lib,v 1.25 2000-03-15 17:17:09 siebert Exp $
+// $Id: poly.lib,v 1.26 2000-05-12 12:17:16 krueger Exp $
 //(GMG, last modified 22.06.96)
 //(obachman: 17.12.97 -- added katsura)
 ///////////////////////////////////////////////////////////////////////////////
 
-version="$Id: poly.lib,v 1.25 2000-03-15 17:17:09 siebert Exp $";
+version="$Id: poly.lib,v 1.26 2000-05-12 12:17:16 krueger Exp $";
 info="
 LIBRARY:  poly.lib      PROCEDURES FOR MANIPULATING POLYS, IDEALS, MODULES
@@ -580,6 +580,6 @@
   degBound=0;
   string mp=string(minpoly);
-  execute "ring R=("+charstr(br)+"),(x(1..n),z),dp;";
-  execute "minpoly=number("+mp+");";
+  execute("ring R=("+charstr(br)+"),(x(1..n),z),dp;");
+  execute("minpoly=number("+mp+");");
   ideal irrel=x(1..n);
   map f=br,irrel;
Index: Singular/LIB/presolve.lib
===================================================================
--- Singular/LIB/presolve.lib	(revision fa1af627353fd9365bd5fdad189f015e30251a16)
+++ Singular/LIB/presolve.lib	(revision 38c1655b00c7eaba87af5a330f66679d70e33495)
@@ -1,7 +1,7 @@
-// $Id: presolve.lib,v 1.12 1999-09-21 17:32:17 Singular Exp $
+// $Id: presolve.lib,v 1.13 2000-05-12 12:17:17 krueger Exp $
 //(GMG)
 ///////////////////////////////////////////////////////////////////////////////
 
-version="$Id: presolve.lib,v 1.12 1999-09-21 17:32:17 Singular Exp $";
+version="$Id: presolve.lib,v 1.13 2000-05-12 12:17:17 krueger Exp $";
 info="
 LIBRARY:  presolve.lib     PROCEDURES FOR PRE-SOLVING POLYNOMIAL EQUATIONS
@@ -97,5 +97,5 @@
    if( fi == 0 or find(ordstr(P),"a") != 0 )
    {
-      execute "ring newP = ("+charstr(P)+"),("+varstr(P)+"),dp;";
+      execute("ring newP = ("+charstr(P)+"),("+varstr(P)+"),dp;");
       ideal i = imap(P,i);
    }
@@ -251,5 +251,5 @@
          if( ordstr(P) != "c,dp(n)" )
          {
-            execute "ring newP = ("+charstr(P)+"),("+varstr(P)+"),(c,dp);";
+            execute("ring newP = ("+charstr(P)+"),("+varstr(P)+"),(c,dp);");
             ideal k1 = imap(P,k1);
             ideal k2 = imap(P,k2);
@@ -363,5 +363,5 @@
    if ( size(b) != 0 ) { b = b[1,size(b)-1]; }
    else { a = a[1,size(a)-1]; }
-   execute "ring gnir ="+charstr(P)+",("+a+b+"),dp;";
+   execute("ring gnir ="+charstr(P)+",("+a+b+"),dp;");
    ideal i = imap(P,i);
    list L = elimpart(i,n,e)+list(n);
@@ -418,5 +418,5 @@
    string newvar = string(L[4]);
    L = L[1],p;
-   execute "ring r1=("+charstr(P)+"),("+newvar+"),"+"dp;";
+   execute("ring r1=("+charstr(P)+"),("+newvar+"),"+"dp;");
    list L = imap(P,L);
 //------------------- find "best" ordering of variables  ----------------------
@@ -444,5 +444,5 @@
    {
       intvec hi = hilbvec(L[1]);         // Hilbert-series of i
-      execute "ring r2=("+charstr(P)+"),("+varstr(basering)+",@homo),dp;";
+      execute("ring r2=("+charstr(P)+"),("+varstr(basering)+",@homo),dp;");
       list L = imap(r1,L);
       L[1] = homog(L[1],@homo);          // @homo = homogenizing var
@@ -532,5 +532,5 @@
    if ( @s==0 )
    {
-      execute "ring "+@s1+"=("+charstr(@P)+"),("+varstr(@P)+"),("+@o+");";
+      execute("ring "+@s1+"=("+charstr(@P)+"),("+varstr(@P)+"),("+@o+");");
       def @id = imap(@P,@id);
       verbose(noredefine);
@@ -567,5 +567,5 @@
    if ( @h != 0 )
    {
-      execute "ring @Q=("+charstr(@P)+"),("+varstr(@P)+",@homo),("+@o+");";
+      execute("ring @Q=("+charstr(@P)+"),("+varstr(@P)+",@homo),("+@o+");");
       def @id = imap(@P,@id);
       kill @P;
@@ -594,5 +594,5 @@
          else { @o = @o[1,size(@o)-8] + @o[size(@o)-1,2]; }
       }
-      execute "ring @P=("+charstr(@Q)+"),("+@va+"),("+@o+");";
+      execute("ring @P=("+charstr(@Q)+"),("+@va+"),("+@o+");");
       def @id = imap(@Q,@id);
    }
@@ -701,7 +701,7 @@
    if ( size(#) == 2 ) {  @c = #[1]; @o = #[2]; }
    string @si = typeof(@id)+" @i = "+string(@id)+";";  //** weg
-   execute "ring @r=("+@c+"),("+varstr(basering)+"),("+@o+");";
+   execute("ring @r=("+@c+"),("+varstr(basering)+"),("+@o+");");
    //**def i = imap(P,@id);
-   execute @si;                   //** weg
+   execute(@si);                   //** weg
    //show(basering);
    @i = std(@i);
@@ -795,5 +795,5 @@
    dbprint( pr,"","// variables which did not occur:",L[3] );
 
-   execute "ring "+s1+"=("+charstr(P)+"),("+newvar+"),("+s2+");";
+   execute("ring "+s1+"=("+charstr(P)+"),("+newvar+"),("+s2+");");
    def id = imap(P,id);
    export(basering);
@@ -943,7 +943,7 @@
    @o=@o[1..size(@o)-1];
 //------------------ create new ring and make objects global -----------------
-   execute "ring "+@s1+"=("+charstr(@P)+"),("+@va+"),("+@o+");";
+   execute("ring "+@s1+"=("+charstr(@P)+"),("+@va+"),("+@o+");");
    def @id = imap(@P,@id);
-   execute "def "+ @s2+"=@id;";
+   execute("def "+ @s2+"=@id;");
    execute("export("+@s1+");");
    execute("export("+@s2+");");
Index: Singular/LIB/ring.lib
===================================================================
--- Singular/LIB/ring.lib	(revision fa1af627353fd9365bd5fdad189f015e30251a16)
+++ Singular/LIB/ring.lib	(revision 38c1655b00c7eaba87af5a330f66679d70e33495)
@@ -1,7 +1,7 @@
-// $Id: ring.lib,v 1.10 1999-07-07 16:38:27 obachman Exp $
+// $Id: ring.lib,v 1.11 2000-05-12 12:17:17 krueger Exp $
 //(GMG, last modified 03.11.95)
 ///////////////////////////////////////////////////////////////////////////////
 
-version="$Id: ring.lib,v 1.10 1999-07-07 16:38:27 obachman Exp $";
+version="$Id: ring.lib,v 1.11 2000-05-12 12:17:17 krueger Exp $";
 info="
 LIBRARY:  ring.lib      PROCEDURES FOR MANIPULATING RINGS AND MAPS
@@ -70,5 +70,9 @@
    kill R,R1;
    if(system("with","Namespaces")) {
-      kill Top::R,Top::R1;
+      if( nameof(Current) == "Ring" ) {
+        kill Top::R,Top::R1;
+      } else {
+        kill Ring::R,Ring::R1;
+      }
    }
 }
@@ -120,5 +124,9 @@
    kill R,Q,Q';
    if(system("with","Namespaces")) {
-      kill Top::R,Top::Q';
+      if( nameof(Current) == "Ring" ) {
+        kill Top::R,Top::Q';
+      } else {
+        kill Ring::R,Ring::Q';
+      }
    }
 }
@@ -181,5 +189,9 @@
    kill R,Q,Q';
    if(system("with","Namespaces")) {
-      kill Top::R,Top::Q';
+      if( nameof(Current) == "Ring" ) {
+        kill Top::R,Top::Q';
+      } else {
+        kill Ring::R,Ring::Q';
+      }
    }
 }
@@ -218,5 +230,9 @@
    kill r,R;
    if(system("with","Namespaces")) {
-      kill Top::r,Top::R;
+      if( nameof(Current) == "Ring" ) {
+        kill Top::r,Top::R;
+      } else {
+        kill Ring::r,Ring::R;
+      }
    }
 }
@@ -254,5 +270,9 @@
    kill S5, S30;
    if(system("with","Namespaces")) {
-      kill Top::S5,Top::S30;
+      if( nameof(Current) == "Ring" ) {
+        kill Top::S5,Top::S30;
+      } else {
+        kill Ring::S5,Ring::S30;
+      }
    }
 }
@@ -291,5 +311,9 @@
    kill P5, P30;
    if(system("with","Namespaces")) {
-      kill Top::P5,Top::P30;
+      if( nameof(Current) == "Ring" ) {
+        kill Top::P5,Top::P30;
+      } else {
+        kill Ring::P5,Ring::P30;
+      }
    }
 }
@@ -448,5 +472,9 @@
    kill r,R1,R2,R3,R4;
    if(system("with","Namespaces")) {
-      kill Top::R1,Top::R2,Top::R3,Top::R4;
+      if( nameof(Current) == "Ring" ) {
+        kill Top::R1,Top::R2,Top::R3,Top::R4;
+      } else {
+        kill Ring::R1,Ring::R2,Ring::R3,Ring::R4;
+      }
    }
 }
@@ -679,6 +707,10 @@
    kill R,Q,S,T;
    if(system("with","Namespaces")) {
-      kill Top::R,Top::Q,Top::S,Top::T;
-   }
-}
-///////////////////////////////////////////////////////////////////////////////
+      if( nameof(Current) == "Ring" ) {
+        kill Top::R,Top::Q,Top::S,Top::T;
+      } else {
+        kill Ring::R,Ring::Q,Ring::S,Ring::T;
+      }
+   }
+}
+///////////////////////////////////////////////////////////////////////////////
Index: Singular/LIB/solve.lib
===================================================================
--- Singular/LIB/solve.lib	(revision fa1af627353fd9365bd5fdad189f015e30251a16)
+++ Singular/LIB/solve.lib	(revision 38c1655b00c7eaba87af5a330f66679d70e33495)
@@ -1,5 +1,5 @@
 ///////////////////////////////////////////////////////////////////////////////
 
-version="$Id: solve.lib,v 1.14 1999-12-02 23:03:52 wenk Exp $";
+version="$Id: solve.lib,v 1.15 2000-05-12 12:17:18 krueger Exp $";
 info="
 LIBRARY: solve.lib     PROCEDURES TO SOLVE POLYNOMIAL SYSTEMS
@@ -565,5 +565,5 @@
     string nrings= "ring "+orings+"C=(real,"+string(prec)
 	+",I),("+varstr(basering)+"),lp;";
-    execute nrings;
+    execute(nrings);
 
     if ( pdebug>=0 )
@@ -786,5 +786,5 @@
     string nrings= "ring "+orings+"C=(real,"+string(prec)
 	+",I),("+varstr(basering)+"),lp;";
-    execute nrings;
+    execute(nrings);
 
     if ( pdebug>=0 )
Index: Singular/LIB/spcurve.lib
===================================================================
--- Singular/LIB/spcurve.lib	(revision fa1af627353fd9365bd5fdad189f015e30251a16)
+++ Singular/LIB/spcurve.lib	(revision 38c1655b00c7eaba87af5a330f66679d70e33495)
@@ -1,7 +1,7 @@
-// $Id: spcurve.lib,v 1.8 1999-07-21 10:10:36 Singular Exp $
+// $Id: spcurve.lib,v 1.9 2000-05-12 12:17:18 krueger Exp $
 // (anne, last modified 31.5.99)
 /////////////////////////////////////////////////////////////////////////////
 
-version="$Id: spcurve.lib,v 1.8 1999-07-21 10:10:36 Singular Exp $";
+version="$Id: spcurve.lib,v 1.9 2000-05-12 12:17:18 krueger Exp $";
 info="
 LIBRARY:  spcurve.lib    PROCEDURES FOR CM CODIMENSION 2 SINGULARITIES
@@ -817,5 +817,5 @@
   }
   string ringre=" ring r=" + charstr(rt) + ",(x,y,z), Ws(" + string(wl[1]) + ");";
-  execute ringre;
+  execute(ringre);
   matrix M=imap(rt,M);
   int ne=size(M);
@@ -874,5 +874,5 @@
                         + string(wl[1]) + ");";
   }
-  execute ringre;
+  execute(ringre);
   module temp=imap(r,t1qh);
   ideal t1qh=mod2id(temp,iv);
@@ -1287,5 +1287,5 @@
 // do the interreduction and convert back
 //----------------------------------------------------------------------
-  execute tempstr;
+  execute(tempstr);
   def motemp=imap(r,motemp);
   motemp=interred(motemp);
Index: Singular/LIB/standard.lib
===================================================================
--- Singular/LIB/standard.lib	(revision fa1af627353fd9365bd5fdad189f015e30251a16)
+++ Singular/LIB/standard.lib	(revision 38c1655b00c7eaba87af5a330f66679d70e33495)
@@ -1,6 +1,6 @@
-// $Id: standard.lib,v 1.47 1999-10-19 12:42:51 obachman Exp $
+// $Id: standard.lib,v 1.48 2000-05-12 12:17:18 krueger Exp $
 //////////////////////////////////////////////////////////////////////////////
 
-version="$Id: standard.lib,v 1.47 1999-10-19 12:42:51 obachman Exp $";
+version="$Id: standard.lib,v 1.48 2000-05-12 12:17:18 krueger Exp $";
 info="
 LIBRARY: standard.lib   PROCEDURES WHICH ARE ALWAYS LOADED AT START-UP
@@ -46,5 +46,5 @@
    }
    else { os = #[1]; }
-   execute "ring sr=("+charstr(dr)+"),("+varstr(dr)+"),"+os+";";
+   execute("ring sr=("+charstr(dr)+"),("+varstr(dr)+"),"+os+";");
    ideal i= fetch(dr,i);
    intvec opt= option(get);
@@ -88,8 +88,8 @@
    }
 
-   execute "ring S = ("+charstr(R)+"),("+varstr(R)+",@t),dp;";
+   execute("ring S = ("+charstr(R)+"),("+varstr(R)+",@t),dp;");
    ideal i=homog(imap(R,i),@t);
    intvec v=hilb(std(i),1);
-   execute "ring T = ("+charstr(R)+"),("+varstr(R)+",@t),("+ordstr(R)+");";
+   execute("ring T = ("+charstr(R)+"),("+varstr(R)+",@t),("+ordstr(R)+");");
    ideal i=fetch(S,i);
    ideal a=std(i,v);
@@ -770,5 +770,5 @@
            "),("+varstr(basering)+",@t,@w),dp;";
   def @newP=basering;
-  execute s;
+  execute(s);
   module b=imap(@newP,b);
   module a=imap(@newP,a);
@@ -793,5 +793,5 @@
            "),("+varstr(basering)+",@t),dp;";
   def @newP=basering;
-  execute s;
+  execute(s);
   module b=imap(@newP,b);
   module a=imap(@newP,a);
@@ -817,5 +817,5 @@
            "),("+varstr(basering)+",@t),dp;";
   def @newP=basering;
-  execute s;
+  execute(s);
   module b=imap(@newP,b);
   module a=imap(@newP,a);
@@ -835,6 +835,6 @@
 {
   def R=basering;
-  execute "ring gnir = ("+charstr(basering)+"),
-                       ("+varstr(basering)+",@t),(C,dp);";
+  execute("ring gnir = ("+charstr(basering)+"),
+                       ("+varstr(basering)+",@t),(C,dp);");
   ideal i=var(nvars(basering))*imap(R,i)+(var(nvars(basering))-1)*imap(R,j);
   ideal j=eliminate(i,var(nvars(basering)));
Index: Singular/LIB/tst.lib
===================================================================
--- Singular/LIB/tst.lib	(revision fa1af627353fd9365bd5fdad189f015e30251a16)
+++ Singular/LIB/tst.lib	(revision 38c1655b00c7eaba87af5a330f66679d70e33495)
@@ -1,7 +1,7 @@
-// $Id: tst.lib,v 1.22 1999-11-23 14:20:48 obachman Exp $
+// $Id: tst.lib,v 1.23 2000-05-12 12:17:19 krueger Exp $
 //(obachman, last modified 6/30/98)
 /////////////////////////////////////////////////////////////////////////////
 
-version="$Id: tst.lib,v 1.22 1999-11-23 14:20:48 obachman Exp $";
+version="$Id: tst.lib,v 1.23 2000-05-12 12:17:19 krueger Exp $";
 info="
 LIBRARY:  tst.lib      PROCEDURES FOR RUNNING AUTOMATIC TST TESTS
@@ -149,5 +149,5 @@
   else
   {
-    execute "int tst_int_timer = " + tst_timer[15,size(tst_timer)] + ";";
+    execute("int tst_int_timer = " + tst_timer[15,size(tst_timer)] + ";");
     return (tst_int_timer);
   }